Index: trunk/NEMO/OPA_SRC/TRD/trdicp.F90
===================================================================
--- trunk/NEMO/OPA_SRC/TRD/trdicp.F90	(revision 485)
+++ trunk/NEMO/OPA_SRC/TRD/trdicp.F90	(revision 503)
@@ -698,8 +622,8 @@
 9403     FORMAT(' horizontal diffusion        ',e20.13,'     ',e20.13)
 9404     FORMAT(' vertical diffusion          ',e20.13,'     ',e20.13)
-9405     FORMAT(' STATIC instability mixing   ',e20.13,'     ',e20.13)
+9405     FORMAT(' static instability mixing   ',e20.13,'     ',e20.13)
 9406     FORMAT(' damping term                ',e20.13,'     ',e20.13)
-9407     FORMAT(' penetrative qsr             ',e20.13,'     ',e20.13)
-9408     FORMAT(' forcing term                ',e20.13,'     ',e20.13)
+9407     FORMAT(' penetrative qsr             ',e20.13)
+9408     FORMAT(' non solar radiation         ',e20.13,'     ',e20.13)
 9409     FORMAT(' -------------------------------------------------------------------------')
 9410     FORMAT(' total trend                 ',e20.13,'     ',e20.13)
@@ -710,17 +634,17 @@
             WRITE (numout,*)
             WRITE (numout,9420) kt
-            WRITE (numout,9421) t2(1) / tvolt, s2(1) / tvolt
-            WRITE (numout,9422) t2(2) / tvolt, s2(2) / tvolt
-            WRITE (numout,9423) t2(3) / tvolt, s2(3) / tvolt
-            WRITE (numout,9424) t2(4) / tvolt, s2(4) / tvolt
-            WRITE (numout,9425) t2(5) / tvolt, s2(5) / tvolt
-            WRITE (numout,9426) t2(6) / tvolt, s2(6) / tvolt
-            WRITE (numout,9427) t2(7) / tvolt
-            WRITE (numout,9428) t2(8) / tvolt, s2(8) / tvolt
+            WRITE (numout,9421) ( t2(jpicpt_xad)+t2(jpicpt_yad) )/ tvolt, ( s2(jpicpt_xad)+s2(jpicpt_yad) )/ tvolt
+            WRITE (numout,9422)   t2(jpicpt_zad) / tvolt, s2(jpicpt_zad) / tvolt
+            WRITE (numout,9423)   t2(jpicpt_ldf) / tvolt, s2(jpicpt_ldf) / tvolt
+            WRITE (numout,9424)   t2(jpicpt_zdf) / tvolt, s2(jpicpt_zdf) / tvolt
+            WRITE (numout,9425)   t2(jpicpt_npc) / tvolt, s2(jpicpt_npc) / tvolt
+            WRITE (numout,9426)   t2(jpicpt_dmp) / tvolt, s2(jpicpt_dmp) / tvolt
+            WRITE (numout,9427)   t2(jpicpt_qsr) / tvolt
+            WRITE (numout,9428)   t2(jpicpt_nsr) / tvolt, s2(jpicpt_nsr) / tvolt
             WRITE (numout,9429)
-            WRITE (numout,9430) (  t2(1) + t2(2) + t2(3) + t2(4)              &
-            &                    + t2(5) + t2(6) + t2(7) + t2(8) ) / tvolt,   &
-            &                   (  s2(1) + s2(2) + s2(3) + s2(4)              &
-            &                    + s2(5) + s2(6)          + s2(8) ) / tvolt
+            WRITE (numout,9430) (  t2(jpicpt_xad) + t2(jpicpt_yad) + t2(jpicpt_zad) + t2(jpicpt_ldf) + t2(jpicpt_zdf)   &
+            &                    + t2(jpicpt_npc) + t2(jpicpt_dmp) + t2(jpicpt_qsr) + t2(jpicpt_nsr) ) / tvolt,   &
+            &                   (  s2(jpicpt_xad) + s2(jpicpt_yad) + s2(jpicpt_zad) + s2(jpicpt_ldf) + s2(jpicpt_zdf)   &
+            &                    + s2(jpicpt_npc) + s2(jpicpt_dmp)                  + s2(jpicpt_nsr) ) / tvolt
          ENDIF
 
@@ -731,8 +655,8 @@
 9423     FORMAT(' horizontal diffusion      * t   ', e20.13, '     ', e20.13)
 9424     FORMAT(' vertical diffusion        * t   ', e20.13, '     ', e20.13)
-9425     FORMAT(' STATIC instability mixing * t   ', e20.13, '     ', e20.13)
+9425     FORMAT(' static instability mixing * t   ', e20.13, '     ', e20.13)
 9426     FORMAT(' damping term              * t   ', e20.13, '     ', e20.13)
-9427     FORMAT(' penetrative qsr           * t   ', e20.13, '     ', e20.13)
-9428     FORMAT(' forcing term              * t   ', e20.13, '     ', e20.13)
+9427     FORMAT(' penetrative qsr           * t   ', e20.13)
+9428     FORMAT(' non solar radiation       * t   ', e20.13, '     ', e20.13)
 9429     FORMAT(' -----------------------------------------------------------------------------')
 9430     FORMAT(' total trend                *t = ', e20.13, '  *s = ', e20.13)
@@ -743,12 +667,15 @@
             WRITE (numout,*)
             WRITE (numout,9440) kt
-            WRITE (numout,9441) ( tmo(1)+tmo(2) )/tvolt, ( smo(1)+smo(2) )/tvolt
-            WRITE (numout,9442)   tmo(3)/tvolt,  smo(3)/tvolt
-            WRITE (numout,9443)   tmo(4)/tvolt,  smo(4)/tvolt
-            WRITE (numout,9444)   tmo(5)/tvolt,  smo(5)/tvolt
-            WRITE (numout,9445) ( t2(1)+t2(2) )/tvolt, ( s2(1)+s2(2) )/tvolt
-            WRITE (numout,9446)   t2(3)/tvolt,   s2(3)/tvolt
-            WRITE (numout,9447)   t2(4)/tvolt,   s2(4)/tvolt
-            WRITE (numout,9448)   t2(5)/tvolt,   s2(5)/tvolt
+            WRITE (numout,9441) ( tmo(jpicpt_xad)+tmo(jpicpt_yad)+tmo(jpicpt_zad) )/tvolt,   &
+            &                   ( smo(jpicpt_xad)+smo(jpicpt_yad)+smo(jpicpt_zad) )/tvolt
+            WRITE (numout,9442)   tmo(jpicpt_zl1)/tvolt,  smo(jpicpt_zl1)/tvolt
+            WRITE (numout,9443)   tmo(jpicpt_ldf)/tvolt,  smo(jpicpt_ldf)/tvolt
+            WRITE (numout,9444)   tmo(jpicpt_zdf)/tvolt,  smo(jpicpt_zdf)/tvolt
+            WRITE (numout,9445)   tmo(jpicpt_npc)/tvolt,  smo(jpicpt_npc)/tvolt
+            WRITE (numout,9446) ( t2(jpicpt_xad)+t2(jpicpt_yad)+t2(jpicpt_zad) )/tvolt,    &
+            &                   ( s2(jpicpt_xad)+s2(jpicpt_yad)+s2(jpicpt_zad) )/tvolt
+            WRITE (numout,9447)   t2(jpicpt_ldf)/tvolt,   s2(jpicpt_ldf)/tvolt
+            WRITE (numout,9448)   t2(jpicpt_zdf)/tvolt,   s2(jpicpt_zdf)/tvolt
+            WRITE (numout,9449)   t2(jpicpt_npc)/tvolt,   s2(jpicpt_npc)/tvolt
          ENDIF
 
@@ -756,15 +683,16 @@
             ' :         temperature','                salinity',/,   &
             ' ==================================')
-9441     FORMAT(' 0 = horizontal+vertical advection      ',e20.13,'       ',e20.13)
-9442     FORMAT(' 0 = horizontal diffusion               ',e20.13,'       ',e20.13)
-9443     FORMAT(' 0 = vertical diffusion                 ',e20.13,'       ',e20.13)
-9444     FORMAT(' 0 = static instability mixing          ',e20.13,'       ',e20.13)
-9445     FORMAT(' 0 = horizontal+vertical advection * t  ',e20.13,'       ',e20.13)
-9446     FORMAT(' 0 > horizontal diffusion          * t  ',e20.13,'       ',e20.13)
-9447     FORMAT(' 0 > vertical diffusion            * t  ',e20.13,'       ',e20.13)
-9448     FORMAT(' 0 > static instability mixing     * t  ',e20.13,'       ',e20.13)
-
+9441     FORMAT(' 0 = horizontal+vertical advection +    ',e20.13,'       ',e20.13)
+9442     FORMAT('     1st lev vertical advection         ',e20.13,'       ',e20.13)
+9443     FORMAT(' 0 = horizontal diffusion               ',e20.13,'       ',e20.13)
+9444     FORMAT(' 0 = vertical diffusion                 ',e20.13,'       ',e20.13)
+9445     FORMAT(' 0 = static instability mixing          ',e20.13,'       ',e20.13)
+9446     FORMAT(' 0 = horizontal+vertical advection * t  ',e20.13,'       ',e20.13)
+9447     FORMAT(' 0 > horizontal diffusion          * t  ',e20.13,'       ',e20.13)
+9448     FORMAT(' 0 > vertical diffusion            * t  ',e20.13,'       ',e20.13)
+9449     FORMAT(' 0 > static instability mixing     * t  ',e20.13,'       ',e20.13)
+         !
       ENDIF
-
+      !
    END SUBROUTINE trd_twr
 
@@ -773,39 +701,19 @@
    !!   Default case :                                         Empty module
    !!----------------------------------------------------------------------
-   LOGICAL, PUBLIC, PARAMETER ::   lk_trdtra = .FALSE.   !: tracers  trend flag
-   LOGICAL, PUBLIC, PARAMETER ::   lk_trddyn = .FALSE.   !: momentum trend flag
 CONTAINS
-   SUBROUTINE trd_2d(ptrd2dx, ptrd2dy, ktrd , ctype)       ! Empty routine
-      REAL, DIMENSION(:,:,:), INTENT( inout ) ::   &
-          ptrd2dx,                     &   ! Temperature or U trend 
-          ptrd2dy                          ! Salinity    or V trend
-      INTEGER, INTENT( in ) ::   ktrd      ! momentum or tracer trend index
-      CHARACTER(len=3), INTENT( in ) ::   &
-         ctype                             ! momentum or tracers trends type
-      WRITE(*,*) 'trd_2d: You should not have seen this print! error ?', ptrd2dx(1,1,1)
-      WRITE(*,*) ' "   ": You should not have seen this print! error ?', ptrd2dy(1,1,1)
-      WRITE(*,*) ' "   ": You should not have seen this print! error ?', ktrd
-      WRITE(*,*) ' "   ": You should not have seen this print! error ?', ctype
+   SUBROUTINE trd_2d( ptrd2dx, ptrd2dy, ktrd , ctype )       ! Empty routine
+      REAL, DIMENSION(:,:) ::   ptrd2dx, ptrd2dy
+      WRITE(*,*) 'trd_2d: You should not have seen this print! error ?', ptrd2dx(1,1), ptrd2dy(1,1), ktrd, ctype
    END SUBROUTINE trd_2d
-   SUBROUTINE trd_3d(ptrd3dx, ptrd3dy, ktrd , ctype)       ! Empty routine
-      REAL, DIMENSION(:,:,:), INTENT( inout ) ::   &
-          ptrd3dx,                     &   ! Temperature or U trend 
-          ptrd3dy                          ! Salinity    or V trend
-      INTEGER, INTENT( in ) ::   ktrd      ! momentum or tracer trend index
-      CHARACTER(len=3), INTENT( in ) ::   &
-         ctype                             ! momentum or tracers trends type
-      WRITE(*,*) 'trd_3d: You should not have seen this print! error ?', ptrd3dx(1,1,1)
-      WRITE(*,*) ' "   ": You should not have seen this print! error ?', ptrd3dy(1,1,1)
-      WRITE(*,*) ' "   ": You should not have seen this print! error ?', ktrd
-      WRITE(*,*) ' "   ": You should not have seen this print! error ?', ctype
+   SUBROUTINE trd_3d( ptrd3dx, ptrd3dy, ktrd , ctype )       ! Empty routine
+      REAL, DIMENSION(:,:,:) ::   ptrd3dx, ptrd3dy
+      WRITE(*,*) 'trd_3d: You should not have seen this print! error ?', ptrd3dx(1,1,1), ptrd3dy(1,1,1), ktrd, ctype
    END SUBROUTINE trd_3d
    SUBROUTINE trd_icp_init               ! Empty routine
    END SUBROUTINE trd_icp_init
    SUBROUTINE trd_dwr( kt )          ! Empty routine
-      INTEGER, INTENT(in) :: kt
       WRITE(*,*) 'trd_dwr: You should not have seen this print! error ?', kt
    END SUBROUTINE trd_dwr
    SUBROUTINE trd_twr( kt )          ! Empty routine
-      INTEGER, INTENT(in) :: kt
       WRITE(*,*) 'trd_twr: You should not have seen this print! error ?', kt
    END SUBROUTINE trd_twr
Index: trunk/NEMO/OPA_SRC/TRD/trdicp_oce.F90
===================================================================
--- trunk/NEMO/OPA_SRC/TRD/trdicp_oce.F90	(revision 485)
+++ trunk/NEMO/OPA_SRC/TRD/trdicp_oce.F90	(revision 503)
@@ -6,13 +6,7 @@
 
    !!----------------------------------------------------------------------
-   !!  OPA 9.0 , LOCEAN-IPSL (2005) 
-   !! $Header$ 
-   !! This software is governed by the CeCILL licence see modipsl/doc/NEMO_CeCILL.txt 
-   !!----------------------------------------------------------------------
-   !!----------------------------------------------------------------------
    !!   'key_trdtra'   or                         tracer trends diagnostics
    !!   'key_trddyn'                            momentum trends diagnostics
    !!----------------------------------------------------------------------
-   !! * Modules used
    USE par_oce                 ! ocean parameters
 
@@ -20,107 +14,81 @@
    PUBLIC
 
-   !! Namelist parameters
-   !!----------------------------------------------------------------------
-   INTEGER  ::      & !!: namdia :  diagnostics on dynamics and/or tracer trends
-      ntrd  = 10 ,  &  !: time step frequency dynamics and tracers trends
-      nctls =  0       !: control surface type for trends vertical integration
+   !! * Shared module variables
+#if  defined key_trdtra   &&   defined key_trddyn    ||   defined key_esopa
+   LOGICAL, PARAMETER ::   lk_trdtra = .TRUE.    !: tracers  trend flag
+   LOGICAL, PARAMETER ::   lk_trddyn = .TRUE.    !: momentum trend flag
+#elif  defined key_trdtra
+   LOGICAL, PARAMETER ::   lk_trdtra = .TRUE.    !: tracers  trend flag
+   LOGICAL, PARAMETER ::   lk_trddyn = .FALSE.   !: momentum trend flag
+#elif  defined key_trddyn
+   LOGICAL, PARAMETER ::   lk_trdtra = .FALSE.   !: tracers  trend flag
+   LOGICAL, PARAMETER ::   lk_trddyn = .TRUE.    !: momentum trend flag
+#else
+   LOGICAL, PARAMETER ::   lk_trdtra = .FALSE.   !: tracers  trend flag
+   LOGICAL, PARAMETER ::   lk_trddyn = .FALSE.   !: momentum trend flag
+#endif
 
    !! Tracers trends diagnostics parameters
    !!---------------------------------------------------------------------
-   INTEGER, PARAMETER ::            &  !: trends index
-      jpttdlad = 1,   &  !: tracer horizontal advection
-      jpttdzad = 2,   &  !: tracer vertical advection
-      jpttdldf = 3,   &  !: tracer horizontal diffusion
-      jpttdzdf = 4,   &  !: tracer vertical diffusion
-      jpttdnpc = 5,   &  !: tracer non penetrative convection
-      jpttddoe = 6,   &  !: tracer D.amping O.r vertical E.iv
-      jpttdqsr = 7,   &  !: tracer penetrative solar radiation
-      jpttdnsr = 8       !: tracer non solar radiation
+   INTEGER, PARAMETER ::   &  !: => tracer trends indexes <=
+        jpicpt_xad =  1,   &  !: x- horizontal advection
+        jpicpt_yad =  2,   &  !: y- horizontal advection
+        jpicpt_zad =  3,   &  !: z- vertical   advection
+        jpicpt_ldf =  4,   &  !: lateral       diffusion
+        jpicpt_zdf =  5,   &  !: vertical diffusion (Kz)
+        jpicpt_bbc =  6,   &  !: Bottom Boundary Condition (geoth. flux) 
+        jpicpt_bbl =  7,   &  !: Bottom Boundary Layer (diffusive/convective)
+        jpicpt_npc =  8,   &  !: static instability mixing
+        jpicpt_dmp =  9,   &  !: damping
+        jpicpt_qsr = 10,   &  !: penetrative solar radiation
+        jpicpt_nsr = 11,   &  !: non solar radiation
+        jpicpt_zl1 = 12       !: first level vertical flux
 
+   INTEGER, PARAMETER ::   &  !: => Total tracer trends indexes <=
+        jptot_tra = 12        !: change it when adding/removing one indice above
+   
    !! Momentum trends diagnostics parameters
    !!---------------------------------------------------------------------
-   INTEGER, PARAMETER ::            &  !: trends index
-      jpdtdhpg =  1,   &  !: dynamic hydrostatic pressure gradient 
-      jpdtdkeg =  2,   &  !: dynamic kinetic energy gradient
-      jpdtdrvo =  3,   &  !: dynamic relative vorticity
-      jpdtdpvo =  4,   &  !: dynamic planetary vorticity
-      jpdtdldf =  5,   &  !: dynamic lateral diffusion
-      jpdtdzad =  6,   &  !: dynamic vertical advection
-      jpdtdzdf =  7,   &  !: dynamic vertical diffusion
-      jpdtdspg =  8,   &  !: dynamic surface pressure gradient
-      jpdtddat =  9,   &  !: dynamic damping term
-      jpdtdswf = 10,   &  !: dynamic surface wind forcing
-      jpdtdbfr = 11       !: dynamic bottom friction 
+   INTEGER, PARAMETER ::   &  !: => dynamic trends indexes <=
+        jpicpd_hpg =  1,   &  !: hydrostatic pressure gradient 
+        jpicpd_keg =  2,   &  !: kinetic energy gradient
+        jpicpd_rvo =  3,   &  !: relative vorticity
+        jpicpd_pvo =  4,   &  !: planetary vorticity
+        jpicpd_ldf =  5,   &  !: lateral diffusion
+        jpicpd_zad =  6,   &  !: vertical advection
+        jpicpd_zdf =  7,   &  !: vertical diffusion
+        jpicpd_spg =  8,   &  !: surface pressure gradient
+        jpicpd_dat =  9,   &  !: damping term
+        jpicpd_swf = 10,   &  !: surface wind forcing
+        jpicpd_bfr = 11       !: bottom friction 
 
-   REAL, DIMENSION(jpi,jpj) ::   &  !:
-      tldfbbl, sldfbbl,          &  ! Temperature/salinity lateral diffusion trends
-      !                             ! in the BBL  
-      tladbbl, sladbbl              ! Temperature/salinity lateral advection trends 
-      !                             ! in the BBL
-
-   REAL, DIMENSION(jpi,jpj,jpk) ::   &  !:
-      tladi, sladi,                  &  ! Temp./sal. MUSCL OR TVD advection fluxes 
-      !                                 ! terms along i- 
-      tladj, sladj                      ! Temp./sal. MUSCL OR TVD advection fluxes 
-      !                                 ! terms along j- 
-#if defined key_ldfslp
-   REAL(wp), DIMENSION(jpi,jpj,jpk) ::   &  !:
-      uldftrd, vldftrd     !: lateral diffusion trend in isopycnal case
-#endif
+   INTEGER, PARAMETER ::   &  !: => Total dynamic trends indexes <=
+        jptot_dyn = 11        !: change it when adding/removing one indice above
+   
 #if   defined key_trdtra   ||   defined key_trddyn   ||   defined key_esopa
 
    !! Variables used for diagnostics
    !!---------------------------------------------------------------------
-   REAL(wp) ::   &  !:
-      tvolt,     &  !: volume of the whole ocean computed at t-points
-      tvolu,     &  !: volume of the whole ocean computed at u-points
-      tvolv         !: volume of the whole ocean computed at v-points
+   REAL(wp) ::   tvolt        !: volume of the whole ocean computed at t-points
+   REAL(wp) ::   tvolu        !: volume of the whole ocean computed at u-points
+   REAL(wp) ::   tvolv        !: volume of the whole ocean computed at v-points
 
    !! Tracers trends diagnostics variables
    !!---------------------------------------------------------------------
-   REAL(wp), DIMENSION(10) ::   &  !:
-      tmo, smo         !: tracers trends average 
-      !                !  tmo(1) : horizontal advection
-      !                !  tmo(2) : vertical advection
-      !                !  tmo(3) : horizontal diffusion
-      !                !  tmo(4) : vertical diffusion
-      !                !  tmo(5) : static instability
-      !                !  tmo(6) : damping OR vertical EIV
-      !                !  tmo(7) : penetrative solar radiation (T only)
-   REAL(wp), DIMENSION(10) ::   &  !:
-      t2, s2           !: tracers square trends average 
-      !                !  t2(1) : horizontal advection
-      !                !  t2(2) : vertical advection
-      !                !  t2(3) : horizontal diffusion
-      !                !  t2(4) : vertical diffusion
-      !                !  t2(5) : static instability
-      !                !  t2(6) : damping OR vertical EIV
-      !                !  t2(7) : penetrative solar radiation (T only)
+   REAL(wp), DIMENSION(jptot_tra) ::   tmo, smo         !: tracers trends average 
+   REAL(wp), DIMENSION(jptot_tra) ::   t2, s2           !: tracers square trends average 
    
    !! Momentum trends diagnostics variables
    !!---------------------------------------------------------------------
-   REAL(wp), DIMENSION(11) ::   &  !:
-      umo, vmo         !: momentum trends average 
-      !                !  umo(1) : hydrostatic pressure gradient
-      !                !  umo(2) : kinetic energy
-      !                !  umo(3) : lateral diffusion geo-pot
-      !                !  umo(4) : 
-      !                !  umo(5) : lateral diffusion
-      !                !  umo(6) : vertical advection
-      !                !  umo(7) : vertical diffusion
-      !                !  umo(8) : surface pressure gradient
-      !                !  umo(9) : 
-
-   REAL(wp), DIMENSION(10) ::   &  !:
-      hke              !: momentum square trends average 
-      !                !  hke(1) : horizontal advection
-      !                !  hke(2) : vertical advection
-
-   REAL(wp) ::   &  !:
-      rpktrd,    &  !: potential to kinetic energy conversion
-      peke          !: conversion potential energy - kinetic energy trend
+   REAL(wp), DIMENSION(jptot_dyn) ::   umo, vmo         !: momentum trends average 
+   REAL(wp), DIMENSION(jptot_dyn) ::   hke              !: momentum square trends average 
+   REAL(wp) ::   rpktrd   !: potential to kinetic energy conversion
+   REAL(wp) ::   peke     !: conversion potential energy - kinetic energy trend
 
 #endif
-
-  !!======================================================================
+   !!----------------------------------------------------------------------
+   !!  OPA 9.0 , LOCEAN-IPSL (2005) 
+   !! $Header$ 
+   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
+   !!======================================================================
 END MODULE trdicp_oce
